/*******************************************************************************
* File Name: PORT0.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_PORT0_H) /* Pins PORT0_H */
#define CY_PINS_PORT0_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "PORT0_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    PORT0_Write(uint8 value) ;
void    PORT0_SetDriveMode(uint8 mode) ;
uint8   PORT0_ReadDataReg(void) ;
uint8   PORT0_Read(void) ;
uint8   PORT0_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define PORT0_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define PORT0_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define PORT0_DM_RES_UP          PIN_DM_RES_UP
#define PORT0_DM_RES_DWN         PIN_DM_RES_DWN
#define PORT0_DM_OD_LO           PIN_DM_OD_LO
#define PORT0_DM_OD_HI           PIN_DM_OD_HI
#define PORT0_DM_STRONG          PIN_DM_STRONG
#define PORT0_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define PORT0_MASK               PORT0__MASK
#define PORT0_SHIFT              PORT0__SHIFT
#define PORT0_WIDTH              8u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define PORT0_PS                     (* (reg8 *) PORT0__PS)
/* Data Register */
#define PORT0_DR                     (* (reg8 *) PORT0__DR)
/* Port Number */
#define PORT0_PRT_NUM                (* (reg8 *) PORT0__PRT) 
/* Connect to Analog Globals */                                                  
#define PORT0_AG                     (* (reg8 *) PORT0__AG)                       
/* Analog MUX bux enable */
#define PORT0_AMUX                   (* (reg8 *) PORT0__AMUX) 
/* Bidirectional Enable */                                                        
#define PORT0_BIE                    (* (reg8 *) PORT0__BIE)
/* Bit-mask for Aliased Register Access */
#define PORT0_BIT_MASK               (* (reg8 *) PORT0__BIT_MASK)
/* Bypass Enable */
#define PORT0_BYP                    (* (reg8 *) PORT0__BYP)
/* Port wide control signals */                                                   
#define PORT0_CTL                    (* (reg8 *) PORT0__CTL)
/* Drive Modes */
#define PORT0_DM0                    (* (reg8 *) PORT0__DM0) 
#define PORT0_DM1                    (* (reg8 *) PORT0__DM1)
#define PORT0_DM2                    (* (reg8 *) PORT0__DM2) 
/* Input Buffer Disable Override */
#define PORT0_INP_DIS                (* (reg8 *) PORT0__INP_DIS)
/* LCD Common or Segment Drive */
#define PORT0_LCD_COM_SEG            (* (reg8 *) PORT0__LCD_COM_SEG)
/* Enable Segment LCD */
#define PORT0_LCD_EN                 (* (reg8 *) PORT0__LCD_EN)
/* Slew Rate Control */
#define PORT0_SLW                    (* (reg8 *) PORT0__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define PORT0_PRTDSI__CAPS_SEL       (* (reg8 *) PORT0__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define PORT0_PRTDSI__DBL_SYNC_IN    (* (reg8 *) PORT0__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define PORT0_PRTDSI__OE_SEL0        (* (reg8 *) PORT0__PRTDSI__OE_SEL0) 
#define PORT0_PRTDSI__OE_SEL1        (* (reg8 *) PORT0__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define PORT0_PRTDSI__OUT_SEL0       (* (reg8 *) PORT0__PRTDSI__OUT_SEL0) 
#define PORT0_PRTDSI__OUT_SEL1       (* (reg8 *) PORT0__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define PORT0_PRTDSI__SYNC_OUT       (* (reg8 *) PORT0__PRTDSI__SYNC_OUT) 


#if defined(PORT0__INTSTAT)  /* Interrupt Registers */

    #define PORT0_INTSTAT                (* (reg8 *) PORT0__INTSTAT)
    #define PORT0_SNAP                   (* (reg8 *) PORT0__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins PORT0_H */


/* [] END OF FILE */
