/*******************************************************************************
* File Name: PinColumn1.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_PinColumn1_H) /* Pins PinColumn1_H */
#define CY_PINS_PinColumn1_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "PinColumn1_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    PinColumn1_Write(uint8 value) ;
void    PinColumn1_SetDriveMode(uint8 mode) ;
uint8   PinColumn1_ReadDataReg(void) ;
uint8   PinColumn1_Read(void) ;
uint8   PinColumn1_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define PinColumn1_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define PinColumn1_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define PinColumn1_DM_RES_UP          PIN_DM_RES_UP
#define PinColumn1_DM_RES_DWN         PIN_DM_RES_DWN
#define PinColumn1_DM_OD_LO           PIN_DM_OD_LO
#define PinColumn1_DM_OD_HI           PIN_DM_OD_HI
#define PinColumn1_DM_STRONG          PIN_DM_STRONG
#define PinColumn1_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define PinColumn1_MASK               PinColumn1__MASK
#define PinColumn1_SHIFT              PinColumn1__SHIFT
#define PinColumn1_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define PinColumn1_PS                     (* (reg8 *) PinColumn1__PS)
/* Data Register */
#define PinColumn1_DR                     (* (reg8 *) PinColumn1__DR)
/* Port Number */
#define PinColumn1_PRT_NUM                (* (reg8 *) PinColumn1__PRT) 
/* Connect to Analog Globals */                                                  
#define PinColumn1_AG                     (* (reg8 *) PinColumn1__AG)                       
/* Analog MUX bux enable */
#define PinColumn1_AMUX                   (* (reg8 *) PinColumn1__AMUX) 
/* Bidirectional Enable */                                                        
#define PinColumn1_BIE                    (* (reg8 *) PinColumn1__BIE)
/* Bit-mask for Aliased Register Access */
#define PinColumn1_BIT_MASK               (* (reg8 *) PinColumn1__BIT_MASK)
/* Bypass Enable */
#define PinColumn1_BYP                    (* (reg8 *) PinColumn1__BYP)
/* Port wide control signals */                                                   
#define PinColumn1_CTL                    (* (reg8 *) PinColumn1__CTL)
/* Drive Modes */
#define PinColumn1_DM0                    (* (reg8 *) PinColumn1__DM0) 
#define PinColumn1_DM1                    (* (reg8 *) PinColumn1__DM1)
#define PinColumn1_DM2                    (* (reg8 *) PinColumn1__DM2) 
/* Input Buffer Disable Override */
#define PinColumn1_INP_DIS                (* (reg8 *) PinColumn1__INP_DIS)
/* LCD Common or Segment Drive */
#define PinColumn1_LCD_COM_SEG            (* (reg8 *) PinColumn1__LCD_COM_SEG)
/* Enable Segment LCD */
#define PinColumn1_LCD_EN                 (* (reg8 *) PinColumn1__LCD_EN)
/* Slew Rate Control */
#define PinColumn1_SLW                    (* (reg8 *) PinColumn1__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define PinColumn1_PRTDSI__CAPS_SEL       (* (reg8 *) PinColumn1__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define PinColumn1_PRTDSI__DBL_SYNC_IN    (* (reg8 *) PinColumn1__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define PinColumn1_PRTDSI__OE_SEL0        (* (reg8 *) PinColumn1__PRTDSI__OE_SEL0) 
#define PinColumn1_PRTDSI__OE_SEL1        (* (reg8 *) PinColumn1__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define PinColumn1_PRTDSI__OUT_SEL0       (* (reg8 *) PinColumn1__PRTDSI__OUT_SEL0) 
#define PinColumn1_PRTDSI__OUT_SEL1       (* (reg8 *) PinColumn1__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define PinColumn1_PRTDSI__SYNC_OUT       (* (reg8 *) PinColumn1__PRTDSI__SYNC_OUT) 


#if defined(PinColumn1__INTSTAT)  /* Interrupt Registers */

    #define PinColumn1_INTSTAT                (* (reg8 *) PinColumn1__INTSTAT)
    #define PinColumn1_SNAP                   (* (reg8 *) PinColumn1__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins PinColumn1_H */


/* [] END OF FILE */
