/*******************************************************************************
* File Name: PinColumn2.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_PinColumn2_H) /* Pins PinColumn2_H */
#define CY_PINS_PinColumn2_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "PinColumn2_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    PinColumn2_Write(uint8 value) ;
void    PinColumn2_SetDriveMode(uint8 mode) ;
uint8   PinColumn2_ReadDataReg(void) ;
uint8   PinColumn2_Read(void) ;
uint8   PinColumn2_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define PinColumn2_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define PinColumn2_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define PinColumn2_DM_RES_UP          PIN_DM_RES_UP
#define PinColumn2_DM_RES_DWN         PIN_DM_RES_DWN
#define PinColumn2_DM_OD_LO           PIN_DM_OD_LO
#define PinColumn2_DM_OD_HI           PIN_DM_OD_HI
#define PinColumn2_DM_STRONG          PIN_DM_STRONG
#define PinColumn2_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define PinColumn2_MASK               PinColumn2__MASK
#define PinColumn2_SHIFT              PinColumn2__SHIFT
#define PinColumn2_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define PinColumn2_PS                     (* (reg8 *) PinColumn2__PS)
/* Data Register */
#define PinColumn2_DR                     (* (reg8 *) PinColumn2__DR)
/* Port Number */
#define PinColumn2_PRT_NUM                (* (reg8 *) PinColumn2__PRT) 
/* Connect to Analog Globals */                                                  
#define PinColumn2_AG                     (* (reg8 *) PinColumn2__AG)                       
/* Analog MUX bux enable */
#define PinColumn2_AMUX                   (* (reg8 *) PinColumn2__AMUX) 
/* Bidirectional Enable */                                                        
#define PinColumn2_BIE                    (* (reg8 *) PinColumn2__BIE)
/* Bit-mask for Aliased Register Access */
#define PinColumn2_BIT_MASK               (* (reg8 *) PinColumn2__BIT_MASK)
/* Bypass Enable */
#define PinColumn2_BYP                    (* (reg8 *) PinColumn2__BYP)
/* Port wide control signals */                                                   
#define PinColumn2_CTL                    (* (reg8 *) PinColumn2__CTL)
/* Drive Modes */
#define PinColumn2_DM0                    (* (reg8 *) PinColumn2__DM0) 
#define PinColumn2_DM1                    (* (reg8 *) PinColumn2__DM1)
#define PinColumn2_DM2                    (* (reg8 *) PinColumn2__DM2) 
/* Input Buffer Disable Override */
#define PinColumn2_INP_DIS                (* (reg8 *) PinColumn2__INP_DIS)
/* LCD Common or Segment Drive */
#define PinColumn2_LCD_COM_SEG            (* (reg8 *) PinColumn2__LCD_COM_SEG)
/* Enable Segment LCD */
#define PinColumn2_LCD_EN                 (* (reg8 *) PinColumn2__LCD_EN)
/* Slew Rate Control */
#define PinColumn2_SLW                    (* (reg8 *) PinColumn2__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define PinColumn2_PRTDSI__CAPS_SEL       (* (reg8 *) PinColumn2__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define PinColumn2_PRTDSI__DBL_SYNC_IN    (* (reg8 *) PinColumn2__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define PinColumn2_PRTDSI__OE_SEL0        (* (reg8 *) PinColumn2__PRTDSI__OE_SEL0) 
#define PinColumn2_PRTDSI__OE_SEL1        (* (reg8 *) PinColumn2__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define PinColumn2_PRTDSI__OUT_SEL0       (* (reg8 *) PinColumn2__PRTDSI__OUT_SEL0) 
#define PinColumn2_PRTDSI__OUT_SEL1       (* (reg8 *) PinColumn2__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define PinColumn2_PRTDSI__SYNC_OUT       (* (reg8 *) PinColumn2__PRTDSI__SYNC_OUT) 


#if defined(PinColumn2__INTSTAT)  /* Interrupt Registers */

    #define PinColumn2_INTSTAT                (* (reg8 *) PinColumn2__INTSTAT)
    #define PinColumn2_SNAP                   (* (reg8 *) PinColumn2__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins PinColumn2_H */


/* [] END OF FILE */
