/*******************************************************************************
* File Name: PinColumn3.h  
* Version 1.80
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_PinColumn3_H) /* Pins PinColumn3_H */
#define CY_PINS_PinColumn3_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "PinColumn3_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    PinColumn3_Write(uint8 value) ;
void    PinColumn3_SetDriveMode(uint8 mode) ;
uint8   PinColumn3_ReadDataReg(void) ;
uint8   PinColumn3_Read(void) ;
uint8   PinColumn3_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define PinColumn3_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define PinColumn3_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define PinColumn3_DM_RES_UP          PIN_DM_RES_UP
#define PinColumn3_DM_RES_DWN         PIN_DM_RES_DWN
#define PinColumn3_DM_OD_LO           PIN_DM_OD_LO
#define PinColumn3_DM_OD_HI           PIN_DM_OD_HI
#define PinColumn3_DM_STRONG          PIN_DM_STRONG
#define PinColumn3_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define PinColumn3_MASK               PinColumn3__MASK
#define PinColumn3_SHIFT              PinColumn3__SHIFT
#define PinColumn3_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define PinColumn3_PS                     (* (reg8 *) PinColumn3__PS)
/* Data Register */
#define PinColumn3_DR                     (* (reg8 *) PinColumn3__DR)
/* Port Number */
#define PinColumn3_PRT_NUM                (* (reg8 *) PinColumn3__PRT) 
/* Connect to Analog Globals */                                                  
#define PinColumn3_AG                     (* (reg8 *) PinColumn3__AG)                       
/* Analog MUX bux enable */
#define PinColumn3_AMUX                   (* (reg8 *) PinColumn3__AMUX) 
/* Bidirectional Enable */                                                        
#define PinColumn3_BIE                    (* (reg8 *) PinColumn3__BIE)
/* Bit-mask for Aliased Register Access */
#define PinColumn3_BIT_MASK               (* (reg8 *) PinColumn3__BIT_MASK)
/* Bypass Enable */
#define PinColumn3_BYP                    (* (reg8 *) PinColumn3__BYP)
/* Port wide control signals */                                                   
#define PinColumn3_CTL                    (* (reg8 *) PinColumn3__CTL)
/* Drive Modes */
#define PinColumn3_DM0                    (* (reg8 *) PinColumn3__DM0) 
#define PinColumn3_DM1                    (* (reg8 *) PinColumn3__DM1)
#define PinColumn3_DM2                    (* (reg8 *) PinColumn3__DM2) 
/* Input Buffer Disable Override */
#define PinColumn3_INP_DIS                (* (reg8 *) PinColumn3__INP_DIS)
/* LCD Common or Segment Drive */
#define PinColumn3_LCD_COM_SEG            (* (reg8 *) PinColumn3__LCD_COM_SEG)
/* Enable Segment LCD */
#define PinColumn3_LCD_EN                 (* (reg8 *) PinColumn3__LCD_EN)
/* Slew Rate Control */
#define PinColumn3_SLW                    (* (reg8 *) PinColumn3__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define PinColumn3_PRTDSI__CAPS_SEL       (* (reg8 *) PinColumn3__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define PinColumn3_PRTDSI__DBL_SYNC_IN    (* (reg8 *) PinColumn3__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define PinColumn3_PRTDSI__OE_SEL0        (* (reg8 *) PinColumn3__PRTDSI__OE_SEL0) 
#define PinColumn3_PRTDSI__OE_SEL1        (* (reg8 *) PinColumn3__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define PinColumn3_PRTDSI__OUT_SEL0       (* (reg8 *) PinColumn3__PRTDSI__OUT_SEL0) 
#define PinColumn3_PRTDSI__OUT_SEL1       (* (reg8 *) PinColumn3__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define PinColumn3_PRTDSI__SYNC_OUT       (* (reg8 *) PinColumn3__PRTDSI__SYNC_OUT) 


#if defined(PinColumn3__INTSTAT)  /* Interrupt Registers */

    #define PinColumn3_INTSTAT                (* (reg8 *) PinColumn3__INTSTAT)
    #define PinColumn3_SNAP                   (* (reg8 *) PinColumn3__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins PinColumn3_H */


/* [] END OF FILE */
