/*******************************************************************************
* File Name: Segment_Int.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_ISR_Segment_Int_H)
#define CY_ISR_Segment_Int_H

#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void Segment_Int_Start(void) ;
void Segment_Int_StartEx(cyisraddress address) ;
void Segment_Int_Stop(void) ;

CY_ISR_PROTO(Segment_Int_Interrupt);

void Segment_Int_SetVector(cyisraddress address) ;
cyisraddress Segment_Int_GetVector(void) ;

void Segment_Int_SetPriority(uint8 priority) ;
uint8 Segment_Int_GetPriority(void) ;

void Segment_Int_Enable(void) ;
uint8 Segment_Int_GetState(void) ;
void Segment_Int_Disable(void) ;

void Segment_Int_SetPending(void) ;
void Segment_Int_ClearPending(void) ;


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the Segment_Int ISR. */
#define Segment_Int_INTC_VECTOR            ((reg16 *) Segment_Int__INTC_VECT)

/* Address of the Segment_Int ISR priority. */
#define Segment_Int_INTC_PRIOR             ((reg8 *) Segment_Int__INTC_PRIOR_REG)

/* Priority of the Segment_Int interrupt. */
#define Segment_Int_INTC_PRIOR_NUMBER      Segment_Int__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable Segment_Int interrupt. */
#define Segment_Int_INTC_SET_EN            ((reg8 *) Segment_Int__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the Segment_Int interrupt. */
#define Segment_Int_INTC_CLR_EN            ((reg8 *) Segment_Int__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the Segment_Int interrupt state to pending. */
#define Segment_Int_INTC_SET_PD            ((reg8 *) Segment_Int__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the Segment_Int interrupt. */
#define Segment_Int_INTC_CLR_PD            ((reg8 *) Segment_Int__INTC_CLR_PD_REG)



#endif /* CY_ISR_Segment_Int_H */


/* [] END OF FILE */
