/*******************************************************************************
* FILENAME: cyfitter_cfg.c
* PSoC Creator 2.2
*
* Description:
* This file is automatically generated by PSoC Creator with device 
* initialization code.  Except for the user defined sections in
* CyClockStartupError(), this file should not be modified.
*
********************************************************************************
* Copyright 2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#include <string.h>
#include <cytypes.h>
#include <cydevice_trm.h>
#include <cyfitter.h>
#include <CyLib.h>
#include <cyfitter_cfg.h>

/* Clock startup error codes                                                   */
#define CYCLOCKSTART_NO_ERROR    0u
#define CYCLOCKSTART_XTAL_ERROR  1u
#define CYCLOCKSTART_32KHZ_ERROR 2u
#define CYCLOCKSTART_PLL_ERROR   3u

#ifdef CY_NEED_CYCLOCKSTARTUPERROR
/*******************************************************************************
* Function Name: CyClockStartupError
********************************************************************************
* Summary:
*  If an error is encountered during clock configuration (crystal startup error,
*  PLL lock error, etc.), the system will end up here.  Unless reimplemented by
*  the customer, this function will stop in an infinite loop.
*
* Parameters:
*   void
*
* Return:
*   void
*
*******************************************************************************/
#if defined(__GNUC__) || defined(__ARMCC_VERSION)
__attribute__ ((unused))
#endif
static void CyClockStartupError(uint8 errorCode);
#if defined(__GNUC__) || defined(__ARMCC_VERSION)
__attribute__ ((unused))
#endif
static void CyClockStartupError(uint8 errorCode)
{
    /* To remove the compiler warning if errorCode not used.                */
    errorCode = errorCode;

    /* `#START CyClockStartupError` */

    /* If we have a clock startup error (bad MHz crystal, PLL lock, etc.),  */
    /* we will end up here to allow the customer to implement something to  */
    /* deal with the clock condition.                                       */

    /* `#END` */

    /* If nothing else, stop here since the clocks have not started         */
    /* correctly.                                                           */
    while(1) {}
}
#endif


#if defined(__GNUC__) || defined(__ARMCC_VERSION)
	#define CYPACKED __attribute__ ((packed))
	#define CYALIGNED __attribute__ ((aligned))
	
	#if defined(__ARMCC_VERSION)
		#define CY_CFG_MEMORY_BARRIER() __memory_changed()
	#else
		#define CY_CFG_MEMORY_BARRIER() __sync_synchronize()
	#endif
	
	/*******************************************************************************
	* Function Name: CYMEMZERO8
	********************************************************************************
	* Summary:
	*  This function is provided as a way to initialize a block of memory to zero
	*  one byte at a time.  While this is a 32bit processor, some of the 
	*  configuration registers are only 8bits wide.  This allows us to initialize
	*  just the registers we care about.
	*
	* Parameters:  
	*   addr  - The first address to start writing zero to.
	*   count - The number of bytes to write 0 to.
	*
	* Return:
	*   void
	*
	*******************************************************************************/
	__attribute__ ((unused))
	static void CYMEMZERO8(void *addr, uint32 count);
	__attribute__ ((unused))
	static void CYMEMZERO8(void *addr, uint32 count)
	{
		volatile uint8 * const addr8 = (volatile uint8 *)addr;
		uint32 i;
		for (i = 0; i < count; i++)
		{
			addr8[i] = 0u;
		}
	}

	/*******************************************************************************
	* Function Name: CYCONFIGCPY8
	********************************************************************************
	* Summary:
	*  This function is provided as a way to copy data from one location to another
	*  one byte at a time.  While this is a 32bit processor, some of the 
	*  configuration registers are only 8bits wide.  This allows us to initialize
	*  just the registers we care about.
	*
	* Parameters:  
	*   dest  - The destination address to copy data to.
	*   src   - The source address to copy data from.
	*   count - The number of bytes to copy from 'src' to 'dest'.
	*
	* Return:
	*   void
	*
	*******************************************************************************/
	__attribute__ ((unused))
	static void CYCONFIGCPY8(void *dest, const void *src, uint32 count);
	__attribute__ ((unused))
	static void CYCONFIGCPY8(void *dest, const void *src, uint32 count)
	{
		volatile uint8 * const dest8 = (volatile uint8 *)dest;
		const uint8 * const src8 = (const uint8 *)src;
		uint32 i;
		for (i = 0; i < count; i++)
		{
			dest8[i] = src8[i];
		}
	}

	/*******************************************************************************
	* Function Name: CYCONFIGCPYCODE8
	********************************************************************************
	* Summary:
	*  This function is provided as a way to copy data from one location to another
	*  one byte at a time.  While this is a 32bit processor, some of the 
	*  configuration registers are only 8bits wide.  This allows us to initialize
	*  just the registers we care about.
	*
	* Parameters:  
	*   dest  - The destination address to copy data to.
	*   src   - The source address to copy data from.
	*   count - The number of bytes to copy from 'src' to 'dest'.
	*
	* Return:
	*   void
	*
	*******************************************************************************/
	__attribute__ ((unused))
	static void CYCONFIGCPYCODE8(void *dest, const void *src, uint32 count);
	__attribute__ ((unused))
	static void CYCONFIGCPYCODE8(void *dest, const void *src, uint32 count)
	{
		CYCONFIGCPY8(dest, src, count);
	}

	__attribute__ ((unused))
	static void CYMEMZERO(void *s, size_t n);
	__attribute__ ((unused))
	static void CYMEMZERO(void *s, size_t n)
	{
		(void)memset(s, 0, n);
	}
	__attribute__ ((unused))
	static void CYCONFIGCPY(void *dest, const void *src, size_t n);
	__attribute__ ((unused))
	static void CYCONFIGCPY(void *dest, const void *src, size_t n)
	{
		(void)memcpy(dest, src, n);
	}
	__attribute__ ((unused))
	static void CYCONFIGCPYCODE(void *dest, const void *src, size_t n);
	__attribute__ ((unused))
	static void CYCONFIGCPYCODE(void *dest, const void *src, size_t n)
	{
		(void)memcpy(dest, src, n);
	}
#else
	#error Unsupported toolchain
#endif

#define CY_CFG_BASE_ADDR_COUNT 23u
typedef struct
{
	uint8 offset;
	uint8 value;
} CYPACKED cy_cfg_addrvalue_t;



/*******************************************************************************
* Function Name: cfg_write_bytes32
********************************************************************************
* Summary:
*  This function is used for setting up the chip configuration areas that
*  contain relatively sparse data.
*
* Parameters:
*   void
*
* Return:
*   void
*
*******************************************************************************/
static void cfg_write_bytes32(const uint32 addr_table[], const cy_cfg_addrvalue_t data_table[]);
static void cfg_write_bytes32(const uint32 addr_table[], const cy_cfg_addrvalue_t data_table[])
{
	/* For 32-bit little-endian architectures */
	uint32 i, j = 0u;
	for (i = 0u; i < CY_CFG_BASE_ADDR_COUNT; i++)
	{
		uint32 baseAddr = addr_table[i];
		uint8 count = (uint8)baseAddr;
		baseAddr &= 0xFFFFFF00u;
		while (count != 0u)
		{
			CY_SET_XTND_REG8((void CYFAR *)(baseAddr + data_table[j].offset), data_table[j].value);
			j++;
			count--;
		}
	}
}

/*******************************************************************************
* Function Name: ClockSetup
********************************************************************************
*
* Summary:
*  Performs the initialization of all of the clocks in the device based on the
*  settings in the Clock tab of the DWR.  This includes enabling the requested
*  clocks and setting the necessary dividers to produce the desired frequency. 
*
* Parameters:
*  void
*
* Return:
*  void
*
*******************************************************************************/
static void ClockSetup(void);
static void ClockSetup(void)
{
	uint32 timeout;
	uint8 pllLock;


	/* Configure Digital Clocks based on settings from Clock DWR */
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_CLKDIST_DCFG0_CFG0), 0x0001u);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_DCFG0_CFG0 + 0x2), 0x18u);

	/* Configure ILO based on settings from Clock DWR */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_SLOWCLK_ILO_CR0), 0x02u);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_CR), 0x08u);

	/* Configure IMO based on settings from Clock DWR */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_FASTCLK_IMO_CR), 0x03u);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_IMO_TR1), (CY_GET_XTND_REG8((void CYFAR *)CYREG_FLSHID_CUST_TABLES_IMO_3MHZ)));

	/* Configure PLL based on settings from Clock DWR */
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_PLL_P), 0x0008u);
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_PLL_CFG0), 0x1051u);
	/* Wait up to 250us for the PLL to lock */
	pllLock = 0u;
	for (timeout = 250u / 10u; (timeout > 0u) && (pllLock != 0x03u); timeout--) { 
		pllLock = 0x03u & ((uint8)((uint8)pllLock << 1) | ((CY_GET_XTND_REG8((void CYFAR *)CYREG_FASTCLK_PLL_SR) & 0x01u) >> 0));
		CyDelayCycles(10u * 12u); /* Delay 10us based on 12MHz clock */
	}

	/* Configure Bus/Master Clock based on settings from Clock DWR */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x03u);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR1), 0x01u);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x00u);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x07u);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_BCFG0), 0x00u);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_BCFG2), 0x48u);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x00u);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_LD), 0x02u);

	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PM_ACT_CFG2), ((CY_GET_XTND_REG8((void CYFAR *)CYREG_PM_ACT_CFG2) | 0x01u)));
}


/* Analog API Functions */


/*******************************************************************************
* Function Name: AnalogSetDefault
********************************************************************************
*
* Summary:
*  Sets up the analog portions of the chip to default values based on chip
*  configuration options from the project.
*
* Parameters:
*  void
*
* Return:
*  void
*
*******************************************************************************/
static void AnalogSetDefault(void);
static void AnalogSetDefault(void)
{
	CY_SET_XTND_REG16((void CYFAR *)CYREG_PM_ACT_CFG10, 0x0310u);
	CY_SET_XTND_REG8((void CYFAR *)CYREG_PRT6_AG, 0x10u);
	CY_SET_XTND_REG8((void CYFAR *)CYREG_DAC0_CR0, 0x1Eu);
	CY_SET_XTND_REG8((void CYFAR *)CYREG_DAC1_CR0, 0x1Eu);
	CY_SET_XTND_REG8((void CYFAR *)CYREG_DAC2_CR0, 0x1Eu);
	CY_SET_XTND_REG8((void CYFAR *)CYREG_DAC3_CR0, 0x1Eu);
	CY_SET_XTND_REG8((void CYFAR *)CYREG_CAPSL_CFG0, 0x00u);
	CY_SET_XTND_REG8((void CYFAR *)CYREG_SAR0_CSR0, 0xC0u);
	CY_SET_XTND_REG8((void CYFAR *)CYREG_SAR0_CSR3, 0x0Cu);
	CY_SET_XTND_REG8((void CYFAR *)CYREG_SAR1_CSR0, 0xC0u);
	CY_SET_XTND_REG8((void CYFAR *)CYREG_SAR1_CSR3, 0x0Cu);
	CY_SET_XTND_REG8((void CYFAR *)CYREG_CMP1_SW3, 0x20u);
	CY_SET_XTND_REG8((void CYFAR *)CYREG_BUS_SW3, 0x01u);
	CY_SET_XTND_REG8((void CYFAR *)CYREG_PUMP_CR0, 0x66u);
}


/*******************************************************************************
* Function Name: SetAnalogRoutingPumps
********************************************************************************
*
* Summary:
* Enables or disables the analog pumps feeding analog routing switches.
* Intended to be called at startup, based on the Vdda system configuration;
* may be called during operation when the user informs us that the Vdda voltage
* crossed the pump threshold.
*
* Parameters:
*  enabled - 1 to enable the pumps, 0 to disable the pumps
*
* Return:
*  void
*
*******************************************************************************/
void SetAnalogRoutingPumps(uint8 enabled)
{
	uint8 regValue = CY_GET_XTND_REG8((void CYFAR *)CYREG_PUMP_CR0);
	if (enabled != 0u)
	{
		regValue |= 0x22u;
	}
	else
	{
		regValue &= (uint8)~0x22u;
	}
	CY_SET_XTND_REG8((void CYFAR *)CYREG_PUMP_CR0, regValue);
}

#define CY_AMUX_UNUSED CYREG_BOOST_SR
/* This is an implementation detail of the AMux. Code that depends on it may be
   incompatible with other versions of PSoC Creator. */
uint8 CYXDATA * const CYCODE CapSense_AMuxCH0__addrTable[5] = {
	(uint8 CYXDATA *)CYREG_PRT5_AMUX, 
	(uint8 CYXDATA *)CYREG_PRT5_AMUX, 
	(uint8 CYXDATA *)CYREG_PRT6_AMUX, 
	(uint8 CYXDATA *)CYREG_CMP1_SW3, 
	(uint8 CYXDATA *)CYREG_DAC1_SW3, 
};

/* This is an implementation detail of the AMux. Code that depends on it may be
   incompatible with other versions of PSoC Creator. */
const uint8 CYCODE CapSense_AMuxCH0__maskTable[5] = {
	0x40u, 
	0x20u, 
	0x10u, 
	0x01u, 
	0x10u, 
};

/*******************************************************************************
* Function Name: CapSense_AMuxCH0_Set
********************************************************************************
* Summary:
*  This function is used to set a particular channel as active on the AMux.
*
* Parameters:  
*   channel - The mux channel input to set as active
*
* Return:
*   void
*
*******************************************************************************/
void CapSense_AMuxCH0_Set(uint8 channel)
{
	if (channel < 5)
	{
		*CapSense_AMuxCH0__addrTable[channel] |= CapSense_AMuxCH0__maskTable[channel];
	}
}

/*******************************************************************************
* Function Name: CapSense_AMuxCH0_Unset
********************************************************************************
* Summary:
*  This function is used to clear a particular channel from being active on the
*  AMux.
*
* Parameters:  
*   channel - The mux channel input to mark inactive
*
* Return:
*   void
*
*******************************************************************************/
void CapSense_AMuxCH0_Unset(uint8 channel)
{
	if (channel < 5)
	{
		*CapSense_AMuxCH0__addrTable[channel] &= (uint8)~CapSense_AMuxCH0__maskTable[channel];
	}
}



/*******************************************************************************
* Function Name: cyfitter_cfg
********************************************************************************
* Summary:
*  This function is called by the start-up code for the selected device. It
*  performs all of the necessary device configuration based on the design
*  settings.  This includes settings from the Design Wide Resources (DWR) such
*  as Clocks and Pins as well as any component configuration that is necessary.
*
* Parameters:  
*   void
*
* Return:
*   void
*
*******************************************************************************/
void cyfitter_cfg(void)
{
	/* IOPINS0_2 Address: CYREG_PRT2_DM0 Size (bytes): 8 */
	static const uint8 CYCODE BS_IOPINS0_2_VAL[] = {
		0x00u, 0x7Fu, 0x7Fu, 0x00u, 0x00u, 0x00u, 0x00u, 0x00u};

	/* IOPINS0_5 Address: CYREG_PRT5_DM0 Size (bytes): 8 */
	static const uint8 CYCODE BS_IOPINS0_5_VAL[] = {
		0x00u, 0x00u, 0x60u, 0x00u, 0x00u, 0x00u, 0x00u, 0x00u};

	/* IOPINS0_6 Address: CYREG_PRT6_DM0 Size (bytes): 8 */
	static const uint8 CYCODE BS_IOPINS0_6_VAL[] = {
		0x00u, 0x0Cu, 0x0Cu, 0x00u, 0x00u, 0x00u, 0x10u, 0x00u};

	/* IOPORT_5 Address: CYDEV_PRTDSI_PRT5_BASE Size (bytes): 7 */
	static const uint8 CYCODE BS_IOPORT_5_VAL[] = {
		0x60u, 0x60u, 0x00u, 0x00u, 0x00u, 0x00u, 0x60u};

#ifdef CYGlobalIntDisable
	/* Disable interrupts by default. Let user enable if/when they want. */
	CYGlobalIntDisable
#endif


	/* Set Flash Cycles based on max possible frequency in case a glitch occurs during ClockSetup(). */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CACHE_CC_CTL), (((CYDEV_INSTRUCT_CACHE_ENABLED) != 0) ? 0x00u : 0x01u));
	/* Setup clocks based on selections from Clock DWR */
	ClockSetup();
	/* Set Flash Cycles based on newly configured 24.00MHz Bus Clock. */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CACHE_CC_CTL), (((CYDEV_INSTRUCT_CACHE_ENABLED) != 0) ? 0x80u : 0x81u));

	/* Disable DMA channels so they can be configured for chip initialization */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PHUB_CH0_BASIC_CFG), 0x00u);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PHUB_CH1_BASIC_CFG), 0x00u);

	/* Enable analog pulldown switches */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_ANAIF_CFG_MISC_CR0), 0x01u);

	/* Enable/Disable Debug functionality based on settings from System DWR */
	CY_SET_XTND_REG8((void CYFAR *)CYREG_MLOGIC_DBG_DBE, (CY_GET_XTND_REG8((void CYFAR *)CYREG_MLOGIC_DBG_DBE) | 0x01u));

	{
		static const uint32 CYCODE cy_cfg_addr_table[] = {
			0x40006408u, /* Base address: 0x40006400 Count: 8 */
			0x40010301u, /* Base address: 0x40010300 Count: 1 */
			0x40010501u, /* Base address: 0x40010500 Count: 1 */
			0x40010602u, /* Base address: 0x40010600 Count: 2 */
			0x40010701u, /* Base address: 0x40010700 Count: 1 */
			0x40010901u, /* Base address: 0x40010900 Count: 1 */
			0x40010A5Bu, /* Base address: 0x40010A00 Count: 91 */
			0x40010B3Au, /* Base address: 0x40010B00 Count: 58 */
			0x40010C40u, /* Base address: 0x40010C00 Count: 64 */
			0x40010D31u, /* Base address: 0x40010D00 Count: 49 */
			0x40010E2Du, /* Base address: 0x40010E00 Count: 45 */
			0x40010F1Fu, /* Base address: 0x40010F00 Count: 31 */
			0x40011702u, /* Base address: 0x40011700 Count: 2 */
			0x40011901u, /* Base address: 0x40011900 Count: 1 */
			0x40014002u, /* Base address: 0x40014000 Count: 2 */
			0x40014103u, /* Base address: 0x40014100 Count: 3 */
			0x40014203u, /* Base address: 0x40014200 Count: 3 */
			0x40014303u, /* Base address: 0x40014300 Count: 3 */
			0x4001450Cu, /* Base address: 0x40014500 Count: 12 */
			0x40014602u, /* Base address: 0x40014600 Count: 2 */
			0x40014805u, /* Base address: 0x40014800 Count: 5 */
			0x40015004u, /* Base address: 0x40015000 Count: 4 */
			0x40015101u, /* Base address: 0x40015100 Count: 1 */
		};

		static const cy_cfg_addrvalue_t CYCODE cy_cfg_data_table[] = {
			{0x0Au, 0xFFu},
			{0x0Bu, 0xFFu},
			{0x0Fu, 0xFFu},
			{0x1Au, 0xFFu},
			{0x1Bu, 0xFFu},
			{0x2Au, 0xFFu},
			{0x2Bu, 0xFFu},
			{0x8Fu, 0x1Fu},
			{0xE6u, 0x04u},
			{0xEAu, 0x01u},
			{0xBEu, 0x10u},
			{0xD8u, 0x04u},
			{0x1Bu, 0x20u},
			{0x9Cu, 0x20u},
			{0x00u, 0x03u},
			{0x02u, 0x14u},
			{0x07u, 0x10u},
			{0x0Bu, 0x04u},
			{0x0Cu, 0x07u},
			{0x10u, 0x07u},
			{0x13u, 0x16u},
			{0x14u, 0x05u},
			{0x16u, 0x02u},
			{0x18u, 0x06u},
			{0x1Au, 0x01u},
			{0x1Eu, 0x08u},
			{0x20u, 0x01u},
			{0x23u, 0x01u},
			{0x29u, 0x16u},
			{0x2Bu, 0x08u},
			{0x2Cu, 0x14u},
			{0x2Du, 0x01u},
			{0x30u, 0x10u},
			{0x31u, 0x01u},
			{0x32u, 0x08u},
			{0x33u, 0x10u},
			{0x34u, 0x07u},
			{0x35u, 0x0Cu},
			{0x37u, 0x02u},
			{0x3Eu, 0x11u},
			{0x3Fu, 0x55u},
			{0x40u, 0x32u},
			{0x41u, 0x05u},
			{0x46u, 0x60u},
			{0x47u, 0x02u},
			{0x48u, 0x18u},
			{0x58u, 0x04u},
			{0x59u, 0x04u},
			{0x5Au, 0x04u},
			{0x61u, 0x0Cu},
			{0x62u, 0xF0u},
			{0x63u, 0x0Cu},
			{0x65u, 0x0Cu},
			{0x67u, 0x0Cu},
			{0x68u, 0x40u},
			{0x69u, 0x4Cu},
			{0x6Au, 0x40u},
			{0x6Bu, 0x4Cu},
			{0x6Cu, 0x90u},
			{0x6Du, 0x58u},
			{0x6Fu, 0x0Cu},
			{0x82u, 0x02u},
			{0x84u, 0x0Bu},
			{0x87u, 0x12u},
			{0x8Bu, 0x06u},
			{0x8Cu, 0x0Au},
			{0x8Eu, 0x01u},
			{0x92u, 0x09u},
			{0x93u, 0x15u},
			{0x96u, 0x04u},
			{0x98u, 0x0Bu},
			{0xA0u, 0x09u},
			{0xA2u, 0x02u},
			{0xA9u, 0x15u},
			{0xABu, 0x08u},
			{0xACu, 0x0Bu},
			{0xB0u, 0x04u},
			{0xB1u, 0x02u},
			{0xB2u, 0x03u},
			{0xB3u, 0x0Cu},
			{0xB5u, 0x10u},
			{0xB6u, 0x08u},
			{0xB7u, 0x01u},
			{0xBEu, 0x44u},
			{0xBFu, 0x55u},
			{0xC0u, 0x32u},
			{0xC1u, 0x04u},
			{0xC5u, 0x02u},
			{0xC6u, 0x60u},
			{0xC8u, 0x09u},
			{0xD8u, 0x04u},
			{0xD9u, 0x04u},
			{0xDAu, 0x04u},
			{0xE1u, 0x0Cu},
			{0xE2u, 0xF0u},
			{0xE3u, 0x0Cu},
			{0xE5u, 0x0Cu},
			{0xE7u, 0x0Cu},
			{0xE8u, 0x40u},
			{0xE9u, 0x4Cu},
			{0xEAu, 0x40u},
			{0xEBu, 0x4Cu},
			{0xECu, 0x90u},
			{0xEDu, 0x58u},
			{0xEFu, 0x0Cu},
			{0x00u, 0x40u},
			{0x01u, 0x03u},
			{0x04u, 0x40u},
			{0x05u, 0x04u},
			{0x07u, 0x40u},
			{0x08u, 0x01u},
			{0x09u, 0x80u},
			{0x0Au, 0x14u},
			{0x0Bu, 0x80u},
			{0x0Eu, 0x64u},
			{0x12u, 0x42u},
			{0x14u, 0x01u},
			{0x15u, 0x01u},
			{0x19u, 0x25u},
			{0x1Au, 0x10u},
			{0x1Bu, 0x08u},
			{0x1Cu, 0x40u},
			{0x1Du, 0x80u},
			{0x1Eu, 0x20u},
			{0x20u, 0x06u},
			{0x21u, 0x06u},
			{0x26u, 0x02u},
			{0x27u, 0x6Au},
			{0x28u, 0x02u},
			{0x29u, 0x01u},
			{0x2Bu, 0x08u},
			{0x2Fu, 0x08u},
			{0x31u, 0x02u},
			{0x35u, 0x01u},
			{0x38u, 0x28u},
			{0x3Fu, 0x28u},
			{0x40u, 0x04u},
			{0x41u, 0x04u},
			{0x47u, 0x2Au},
			{0x48u, 0x01u},
			{0x4Fu, 0x08u},
			{0x50u, 0x14u},
			{0x57u, 0x10u},
			{0x92u, 0x44u},
			{0x93u, 0x80u},
			{0x94u, 0x40u},
			{0x98u, 0x02u},
			{0x99u, 0x02u},
			{0x9Au, 0x40u},
			{0x9Cu, 0x20u},
			{0x9Du, 0x20u},
			{0xA7u, 0x08u},
			{0xA8u, 0x20u},
			{0xABu, 0x20u},
			{0xC0u, 0xB9u},
			{0xC2u, 0x7Fu},
			{0xC4u, 0x99u},
			{0xCAu, 0x2Du},
			{0xCCu, 0x81u},
			{0xCEu, 0x66u},
			{0xD0u, 0xE6u},
			{0xD2u, 0x08u},
			{0xECu, 0x04u},
			{0x00u, 0x08u},
			{0x01u, 0x10u},
			{0x02u, 0x10u},
			{0x03u, 0x20u},
			{0x0Bu, 0x02u},
			{0x0Eu, 0x01u},
			{0x0Fu, 0x20u},
			{0x16u, 0x04u},
			{0x17u, 0x10u},
			{0x18u, 0x10u},
			{0x1Au, 0x08u},
			{0x1Bu, 0x04u},
			{0x1Cu, 0x18u},
			{0x1Du, 0x0Au},
			{0x1Eu, 0x02u},
			{0x1Fu, 0x01u},
			{0x21u, 0x09u},
			{0x23u, 0x02u},
			{0x24u, 0x10u},
			{0x25u, 0x0Bu},
			{0x2Au, 0x02u},
			{0x2Fu, 0x09u},
			{0x30u, 0x02u},
			{0x31u, 0x04u},
			{0x32u, 0x18u},
			{0x33u, 0x30u},
			{0x34u, 0x01u},
			{0x35u, 0x03u},
			{0x36u, 0x04u},
			{0x37u, 0x08u},
			{0x3Eu, 0x05u},
			{0x3Fu, 0x54u},
			{0x40u, 0x03u},
			{0x41u, 0x02u},
			{0x46u, 0x0Au},
			{0x49u, 0xFFu},
			{0x4Au, 0xFFu},
			{0x4Bu, 0xFFu},
			{0x4Cu, 0x02u},
			{0x4Eu, 0xF0u},
			{0x58u, 0x04u},
			{0x59u, 0x04u},
			{0x5Au, 0x04u},
			{0x5Bu, 0x04u},
			{0x62u, 0x48u},
			{0x63u, 0xA1u},
			{0x68u, 0xF0u},
			{0x6Au, 0xF0u},
			{0x6Cu, 0xF0u},
			{0x6Eu, 0xF0u},
			{0x8Au, 0x02u},
			{0x8Du, 0x01u},
			{0x95u, 0x01u},
			{0x9Bu, 0x01u},
			{0x9Du, 0x01u},
			{0xA1u, 0x01u},
			{0xAEu, 0x01u},
			{0xAFu, 0x01u},
			{0xB0u, 0x01u},
			{0xB1u, 0x01u},
			{0xB4u, 0x02u},
			{0xBFu, 0x01u},
			{0xD8u, 0x04u},
			{0xD9u, 0x04u},
			{0x01u, 0x20u},
			{0x04u, 0x01u},
			{0x07u, 0x01u},
			{0x0Du, 0x20u},
			{0x0Eu, 0x22u},
			{0x12u, 0x02u},
			{0x17u, 0x14u},
			{0x19u, 0x12u},
			{0x1Au, 0x84u},
			{0x1Cu, 0x01u},
			{0x1Du, 0x20u},
			{0x1Eu, 0x60u},
			{0x1Fu, 0xD0u},
			{0x22u, 0x02u},
			{0x26u, 0x21u},
			{0x27u, 0x61u},
			{0x2Au, 0x40u},
			{0x2Bu, 0x80u},
			{0x2Fu, 0x52u},
			{0x31u, 0x10u},
			{0x32u, 0x40u},
			{0x33u, 0x08u},
			{0x36u, 0x20u},
			{0x37u, 0x48u},
			{0x38u, 0x40u},
			{0x3Eu, 0x12u},
			{0x3Fu, 0x80u},
			{0x45u, 0x28u},
			{0x57u, 0x40u},
			{0x6Eu, 0x10u},
			{0x6Fu, 0x16u},
			{0x76u, 0x02u},
			{0x80u, 0x40u},
			{0x8Cu, 0x80u},
			{0x97u, 0x20u},
			{0x98u, 0x02u},
			{0x9Au, 0x40u},
			{0x9Bu, 0x08u},
			{0x9Cu, 0xA0u},
			{0xA1u, 0x08u},
			{0xA5u, 0x20u},
			{0xB4u, 0x01u},
			{0xC0u, 0x92u},
			{0xC2u, 0xE0u},
			{0xC4u, 0x61u},
			{0xCAu, 0xD9u},
			{0xCCu, 0x7Eu},
			{0xCEu, 0xB8u},
			{0xD0u, 0x60u},
			{0x08u, 0x01u},
			{0x10u, 0x02u},
			{0x32u, 0x02u},
			{0x36u, 0x01u},
			{0x3Eu, 0x44u},
			{0x56u, 0x08u},
			{0x58u, 0x04u},
			{0x5Bu, 0x0Cu},
			{0x81u, 0x02u},
			{0x85u, 0x02u},
			{0x98u, 0x02u},
			{0x9Bu, 0x01u},
			{0x9Eu, 0x04u},
			{0xA6u, 0x03u},
			{0xB2u, 0x04u},
			{0xB3u, 0x02u},
			{0xB4u, 0x01u},
			{0xB5u, 0x01u},
			{0xB6u, 0x02u},
			{0xB9u, 0x08u},
			{0xBEu, 0x40u},
			{0xBFu, 0x04u},
			{0xC0u, 0x62u},
			{0xC5u, 0x54u},
			{0xC6u, 0x20u},
			{0xC8u, 0x0Bu},
			{0xC9u, 0xFFu},
			{0xCAu, 0xFFu},
			{0xCBu, 0xFFu},
			{0xCCu, 0x02u},
			{0xCDu, 0x20u},
			{0xCFu, 0x05u},
			{0xD1u, 0x10u},
			{0xD6u, 0x02u},
			{0xD7u, 0x11u},
			{0xD8u, 0x04u},
			{0xD9u, 0x04u},
			{0xDAu, 0x04u},
			{0xDBu, 0x04u},
			{0xDEu, 0x0Au},
			{0xE0u, 0x40u},
			{0xE1u, 0x40u},
			{0xE2u, 0x80u},
			{0xE4u, 0x80u},
			{0xE6u, 0x80u},
			{0x00u, 0x10u},
			{0x08u, 0x02u},
			{0x0Eu, 0x0Au},
			{0x17u, 0x08u},
			{0x18u, 0x12u},
			{0x1Du, 0x08u},
			{0x1Eu, 0x0Au},
			{0x27u, 0x28u},
			{0x37u, 0x20u},
			{0x39u, 0x40u},
			{0x3Au, 0x40u},
			{0x3Fu, 0x09u},
			{0x45u, 0x20u},
			{0x4Fu, 0x29u},
			{0x57u, 0x10u},
			{0x58u, 0x80u},
			{0x5Cu, 0x20u},
			{0x60u, 0x02u},
			{0x76u, 0x40u},
			{0x79u, 0x40u},
			{0x7Fu, 0x10u},
			{0xC0u, 0x02u},
			{0xC2u, 0xC8u},
			{0xC4u, 0x20u},
			{0xCCu, 0x20u},
			{0xCEu, 0xC0u},
			{0xD0u, 0x20u},
			{0xD2u, 0x20u},
			{0xD6u, 0x28u},
			{0xD8u, 0x08u},
			{0xDEu, 0x48u},
			{0xAFu, 0x20u},
			{0xECu, 0x08u},
			{0xACu, 0x20u},
			{0x31u, 0x10u},
			{0xCCu, 0x10u},
			{0x81u, 0x10u},
			{0x9Du, 0x10u},
			{0xE6u, 0x20u},
			{0x9Bu, 0x20u},
			{0xABu, 0x20u},
			{0xEAu, 0x80u},
			{0x6Bu, 0x20u},
			{0x9Bu, 0x20u},
			{0xDAu, 0x40u},
			{0x20u, 0x10u},
			{0x34u, 0x08u},
			{0x35u, 0x10u},
			{0x38u, 0x40u},
			{0x8Cu, 0x10u},
			{0x90u, 0x40u},
			{0xB4u, 0x40u},
			{0xC8u, 0x02u},
			{0xCCu, 0x05u},
			{0xCEu, 0x08u},
			{0xE2u, 0x08u},
			{0xE8u, 0x02u},
			{0xA8u, 0x08u},
			{0xA9u, 0x10u},
			{0x66u, 0x02u},
			{0x9Au, 0x02u},
			{0xAEu, 0x02u},
			{0xD8u, 0x80u},
			{0xEEu, 0x10u},
			{0x00u, 0x01u},
			{0x02u, 0x10u},
			{0x0Cu, 0x01u},
			{0x0Eu, 0x01u},
			{0x00u, 0x03u},
		};



		typedef struct {
			void CYFAR *address;
			uint16 size;
		} CYPACKED cfg_memset_t;

		static const cfg_memset_t CYCODE cfg_memset_list [] = {
			/* address, size */
			{(void CYFAR *)(CYREG_PRT0_DR), 32u},
			{(void CYFAR *)(CYREG_PRT3_DR), 32u},
			{(void CYFAR *)(CYREG_PRT12_DR), 16u},
			{(void CYFAR *)(CYREG_PRT15_DR), 16u},
			{(void CYFAR *)(CYDEV_UCFG_B0_P0_U0_BASE), 4096u},
			{(void CYFAR *)(CYDEV_UCFG_B1_P2_U0_BASE), 2048u},
			{(void CYFAR *)(CYDEV_UCFG_DSI0_BASE), 2560u},
			{(void CYFAR *)(CYDEV_UCFG_DSI12_BASE), 512u},
		};

		uint8 CYDATA i;

		/* Zero out critical memory blocks before beginning configuration */
		for (i = 0u; i < (sizeof(cfg_memset_list)/sizeof(cfg_memset_list[0])); i++)
		{
			const cfg_memset_t CYCODE * CYDATA ms = &cfg_memset_list[i];
			CYMEMZERO(ms->address, ms->size);
		}

		cfg_write_bytes32(cy_cfg_addr_table, cy_cfg_data_table);

		/* Perform normal device configuration. Order is not critical for these items. */
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT0_BASE), 7u);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT1_BASE), 7u);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT2_BASE), 7u);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT3_BASE), 7u);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT4_BASE), 7u);
		CYCONFIGCPYCODE8((void CYFAR *)(CYDEV_PRTDSI_PRT5_BASE), (const void CYCODE *)(BS_IOPORT_5_VAL), 7u);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT6_BASE), 7u);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT12_BASE), 6u);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT15_BASE), 7u);
		CY_SET_XTND_REG16((void CYFAR *)(CYREG_CAPSR_CFG0), 0x0300u);
		CY_SET_XTND_REG16((void CYFAR *)(CYREG_LUT1_CR), 0x0103u);

		/* Enable digital routing */
		CY_SET_XTND_REG8((void CYFAR *)CYREG_BCTL0_BANK_CTL, CY_GET_XTND_REG8((void CYFAR *)CYREG_BCTL0_BANK_CTL) | 0x02u);
		CY_SET_XTND_REG8((void CYFAR *)CYREG_BCTL1_BANK_CTL, CY_GET_XTND_REG8((void CYFAR *)CYREG_BCTL1_BANK_CTL) | 0x02u);

		/* Enable UDB array */
		CY_SET_XTND_REG8((void CYFAR *)CYREG_PM_ACT_CFG0, CY_GET_XTND_REG8((void CYFAR *)CYREG_PM_ACT_CFG0) | 0x40u);
		CY_SET_XTND_REG8((void CYFAR *)CYREG_PM_AVAIL_CR2, CY_GET_XTND_REG8((void CYFAR *)CYREG_PM_AVAIL_CR2) | 0x10u);
	}

	/* Perform second pass device configuration. These items must be configured in specific order after the regular configuration is done. */
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT2_DM0), (const void CYCODE *)(BS_IOPINS0_2_VAL), 8u);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT5_DM0), (const void CYCODE *)(BS_IOPINS0_5_VAL), 8u);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT6_DM0), (const void CYCODE *)(BS_IOPINS0_6_VAL), 8u);


	/* Perform basic analog initialization to defaults */
	AnalogSetDefault();

	/* Configure alternate active mode */
	CYCONFIGCPY((void CYFAR *)CYDEV_PM_STBY_BASE, (const void CYFAR *)CYDEV_PM_ACT_BASE, 12u);
	CY_SET_XTND_REG8((void CYFAR *)CYREG_PM_STBY_CFG0, CY_GET_XTND_REG8((void CYFAR *)CYREG_PM_STBY_CFG0) & (uint8)~0x02u);	/* Disable CPU */
}
